/*!
 * react-timepicki v2.0.0 - https://github.com/senthilraj/react-timepicki#readme
 * MIT Licensed
 */
(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("react"));
	else if(typeof define === 'function' && define.amd)
		define(["react"], factory);
	else if(typeof exports === 'object')
		exports["ReactTimepicki"] = factory(require("react"));
	else
		root["ReactTimepicki"] = factory(root["React"]);
})(window, function(__WEBPACK_EXTERNAL_MODULE__0__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 1);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE__0__;

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(4);


/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

// extracted by mini-css-extract-plugin

/***/ }),
/* 3 */,
/* 4 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);

// EXTERNAL MODULE: external {"root":"React","commonjs2":"react","commonjs":"react","amd":"react"}
var external_root_React_commonjs2_react_commonjs_react_amd_react_ = __webpack_require__(0);
var external_root_React_commonjs2_react_commonjs_react_amd_react_default = /*#__PURE__*/__webpack_require__.n(external_root_React_commonjs2_react_commonjs_react_amd_react_);

// EXTERNAL MODULE: ./src/ReactTimePicki.css
var src_ReactTimePicki = __webpack_require__(2);

// CONCATENATED MODULE: ./src/ReactTimePicki.js
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }




var ReactTimePicki_ReactTimePicki = function (_React$Component) {
	_inherits(ReactTimePicki, _React$Component);

	function ReactTimePicki(props) {
		_classCallCheck(this, ReactTimePicki);

		var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

		_this.state = {
			showPicker: false,
			currentDate: new Date(),
			meridian: "AM",
			time: {
				hr: _this
				//min: this.state.currentDate.getMinutes()
			},
			value: _this.props.value ? _this.props.value : ''
		};
		_this.timePickiClickHandler = _this.timePickiClickHandler.bind(_this);
		_this.setValueClickHandler = _this.setValueClickHandler.bind(_this);
		return _this;
	}

	ReactTimePicki.prototype.timePickiClickHandler = function timePickiClickHandler() {
		var showPicker = this.state.showPicker;
		if (showPicker) {
			return;
		} else {}
		var currentDate = new Date();
		var currentHours = currentDate.getHours();
		var meridian = "AM";
		if (this.props.timeFormat && this.props.timeFormat === "12") {
			meridian = Math.floor(currentHours / 12) === 1 ? "PM" : "AM";
			currentHours = currentHours % 12;
			currentHours = currentHours === 0 ? 12 : currentHours;
		}
		this.setState({
			showPicker: true,
			currentHours: currentHours,
			currentMinutes: currentDate.getMinutes(),
			meridian: meridian
		});
	};

	ReactTimePicki.prototype.valueChangeHours = function valueChangeHours(e) {
		var currentHours = e.target.value.replace(/[^0-9.]/g, '');
		var meridian = "AM";
		if (this.props.timeFormat === "12" && 12 < currentHours) {
			meridian = Math.floor(currentHours / 12) === 1 ? "PM" : "AM";
			currentHours = 12;
		} else if (this.props.timeFormat === "24" && 23 < currentHours) {
			currentHours = 23;
		} else {
			//("0"+currentHours).split(-2)
		}
		this.setState({ currentHours: currentHours, meridian: meridian });
	};

	ReactTimePicki.prototype.valueChangeMinutes = function valueChangeMinutes(e) {
		var currentMinutes = e.target.value.replace(/[^0-9.]/g, '');
		if (59 < currentMinutes) {
			currentMinutes = 59;
		}
		this.setState({ currentMinutes: currentMinutes });
	};

	ReactTimePicki.prototype.setValueClickHandler = function setValueClickHandler() {
		var setTime = "";
		var getTime = {};
		if (this.props.timeFormat === "12") {
			setTime = ("0" + this.state.currentHours).slice(-2) + " : " + ("0" + this.state.currentMinutes).slice(-2) + " : " + this.state.meridian;
			getTime.hour = ("0" + this.state.currentHours).slice(-2);
			getTime.mins = ("0" + this.state.currentMinutes).slice(-2);
			getTime.mer = this.state.meridian;
		} else {
			setTime = ("0" + this.state.currentHours).slice(-2) + " : " + ("0" + this.state.currentMinutes).slice(-2);
			getTime.hour = ("0" + this.state.currentHours).slice(-2);
			getTime.mins = ("0" + this.state.currentMinutes).slice(-2);
		}
		this.setState({ value: setTime, showPicker: false });
		this.props.getTime(setTime, getTime);
	};

	ReactTimePicki.prototype.resetValueClickHandler = function resetValueClickHandler() {
		this.setState({ value: "" });
	};

	ReactTimePicki.prototype.closeClickHandler = function closeClickHandler() {
		this.setState({ showPicker: false });
	};

	ReactTimePicki.prototype.arrowClickHandler = function arrowClickHandler(field, direction, e) {
		if (field === 'hour' && direction === "up") {
			if (this.props.timeFormat === "24" && this.state.currentHours < 24 || this.props.timeFormat === "12" && this.state.currentHours < 12) {
				this.setState({ currentHours: this.state.currentHours + 1 });
			} else if (this.props.timeFormat === "24" && 23 < this.state.currentHours) {
				this.setState({ currentHours: 0 });
			} else if (this.props.timeFormat === "12" && 12 <= this.state.currentHours) {
				this.setState({ currentHours: 1 });
			}
		} else if (field === 'hour' && direction === "down") {
			if (this.state.currentHours !== 0 && (this.props.timeFormat === "12" && this.state.currentHours !== 1 || this.props.timeFormat === "24")) {
				this.setState({ currentHours: this.state.currentHours - 1 });
			} else if (this.props.timeFormat === "24" && this.state.currentHours === 0) {
				this.setState({ currentHours: 23 });
			} else if (this.props.timeFormat === "12" && this.state.currentHours === 0) {
				this.setState({ currentHours: 12 });
			} else {
				this.setState({ currentHours: 12 });
			}
		} else if (field === 'min' && direction === "up") {
			if (this.state.currentMinutes < 59) {
				this.setState({ currentMinutes: this.state.currentMinutes + 1 });
			} else {
				this.setState({ currentMinutes: 0 });
			}
		} else if (field === 'min' && direction === "down") {
			if (this.state.currentMinutes !== 0) {
				this.setState({ currentMinutes: this.state.currentMinutes - 1 });
			} else {
				this.setState({ currentMinutes: 59 });
			}
		} else if (field === 'meri' && (direction === "down" || direction === "up")) {
			var meridian = this.state.meridian === 'AM' ? 'PM' : 'AM';
			this.setState({ meridian: meridian });
		}
	};

	ReactTimePicki.prototype.renderTimepicki = function renderTimepicki() {
		if (this.state.showPicker) {
			return external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement(
				"div",
				{ className: "timepicki-container " + this.renderWidthClass() },
				external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement(
					"span",
					{ onClick: this.closeClickHandler.bind(this), className: "close-icon" },
					external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement(
						"strong",
						null,
						"x"
					)
				),
				external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement(
					"div",
					{ className: "timepicki-input-wrap timepicki-input-wrap-left" },
					external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement("span", { className: "timepicki-arrow up-arrow", onClick: this.arrowClickHandler.bind(this, "hour", "up") }),
					external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement(
						"span",
						null,
						external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement("input", { className: "timepicki-input", type: "text", maxLength: "2", onChange: this.valueChangeHours.bind(this), value: this.state.currentHours, name: "" })
					),
					external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement("span", { className: "timepicki-arrow down-arrow", onClick: this.arrowClickHandler.bind(this, "hour", "down") })
				),
				external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement(
					"div",
					{ className: "timepicki-input-wrap" },
					external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement("span", { className: "timepicki-arrow up-arrow", onClick: this.arrowClickHandler.bind(this, "min", "up") }),
					external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement(
						"span",
						null,
						external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement("input", { className: "timepicki-input", type: "text", maxLength: "2", onChange: this.valueChangeMinutes.bind(this), value: this.state.currentMinutes, name: "" })
					),
					external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement("span", { className: "timepicki-arrow down-arrow", onClick: this.arrowClickHandler.bind(this, "min", "down") })
				),
				this.renderMeridian(),
				external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement(
					"div",
					{ className: "timepicki-button-container" },
					external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement(
						"button",
						{ className: "timepicki-button timepicki-done-button", onClick: this.setValueClickHandler.bind(this) },
						"Done"
					),
					external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement(
						"button",
						{ className: "timepicki-button timepicki-reset-button", onClick: this.resetValueClickHandler.bind(this) },
						"Reset"
					)
				)
			);
		} else {
			return null;
		}
	};

	ReactTimePicki.prototype.renderWidthClass = function renderWidthClass() {
		if (this.props.timeFormat === "12") {
			return "timepicki-container-normal";
		} else return "timepicki-container-meridian";
	};

	ReactTimePicki.prototype.renderMeridian = function renderMeridian() {
		if (this.props.timeFormat === "12") {
			return external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement(
				"div",
				{ className: "timepicki-input-wrap timepicki-input-wrap-right" },
				external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement("span", { className: "timepicki-arrow up-arrow", onClick: this.arrowClickHandler.bind(this, "meri", "up") }),
				external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement(
					"span",
					null,
					external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement("input", { className: "timepicki-input", type: "text", maxLength: "2", name: "", value: this.state.meridian, readOnly: true })
				),
				external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement("span", { className: "timepicki-arrow down-arrow", onClick: this.arrowClickHandler.bind(this, "meri", "down") })
			);
		} else return null;
	};

	ReactTimePicki.prototype.render = function render() {
		var _this2 = this;

		return external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement(
			"div",
			{ className: "input-wrapper" },
			external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.createElement("input", { type: "text", onClick: this.timePickiClickHandler, value: this.state.value, placeholder: this.props.placeholder, onChange: function onChange(e) {
					return _this2.props.onChange && _this2.props.onChange(e.target.value);
				} }),
			this.renderTimepicki()
		);
	};

	return ReactTimePicki;
}(external_root_React_commonjs2_react_commonjs_react_amd_react_default.a.Component);

/* harmony default export */ var src_ReactTimePicki_0 = (ReactTimePicki_ReactTimePicki);
// CONCATENATED MODULE: ./src/index.js

/* harmony default export */ var src = __webpack_exports__["default"] = (src_ReactTimePicki_0);

/***/ })
/******/ ])["default"];
});